package de.thdeg.grademanager.gui;

import de.thdeg.grademanager.JpaService;
import de.thdeg.grademanager.model.Course;
import de.thdeg.grademanager.model.Student;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.ListView;

import java.io.IOException;
import java.util.List;

public class StudentCoursesGradesController {

    private static Student student;

    public static void setStudent(Student student) {
        StudentCoursesGradesController.student = student;
    }

    @FXML
    protected ListView<Course> availableCoursesListView;

    @FXML
    protected ListView<Course> selectedCoursesListView;

    @FXML
    protected void initialize() {
            initEnrollmentsForCoursesOfStudy();
    }

    private void initEnrollmentsForCoursesOfStudy(){
        JpaService jpaService = JpaService.getInstance();
        List<Course> courses = jpaService.getCoursesForCoursesOfStudyFromDb(student.getCoursesOfStudy());
        Student s = jpaService.getStudentFromDb(student.getId());
        jpaService.runInTransaction(entityManager -> {entityManager.detach(s); return null;});
        s.clearEnrollmentsOldCoursesOfStudy(s.getCoursesOfStudy());
        s.initEnrollments(courses);
        jpaService.runInTransaction(entityManager -> {entityManager.merge(s); return null;});
    }

    @FXML
    protected void switchToStudentDetails(ActionEvent event) throws IOException {
        StudentDetailsController.setStudent(student);
        SwitchWindowHelper.switchTo("Student Details", event);
    }
}
